'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         zXref 1.05 include file                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                 PB9+ full SDK version by Patrice TERRIER                 |
'|                            copyright(c) 2009                             |
'|                           www.zapsolution.com                            |
'|                        pterrier@zapsolution.com                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 08-12-2009 (MM-DD-YYYY)            |
'|                        Last revised : 08-19-2009 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

%WINAPI                                         = 1
%TRUE                                           = 1
%FALSE                                          = 0
%NULL                                           = 0
%GENERIC_READ                                   = &H80000000&
%GENERIC_WRITE                                  = &H40000000&
%FILE_SHARE_READ                                = &H00000001
%FILE_SHARE_WRITE                               = &H00000002
%FILE_ATTRIBUTE_NORMAL                          = &H00000080
%ERROR_SUCCESS                                  = 0
%INVALID_HANDLE_VALUE                           = &HFFFFFFFF???
%FILE_FLAG_WRITE_THROUGH                        = &H080000000
%OPEN_ALWAYS                                    = 4
%KEY_QUERY_VALUE                                = &H1
%FILE_TYPE_DISK                                 = &H1
%MAX_PATH                                       = 260  ' max. length of full pathname
%NULL_BRUSH                                     = 5
%ANSI_VAR_FONT                                  = 12
%SW_SHOWNORMAL                                  = 1
%WM_CREATE                                      = &H1
%WM_DESTROY                                     = &H2
%WM_SETTEXT                                     = &HC
%WM_GETTEXT                                     = &HD
%WM_ERASEBKGND                                  = &H14
%WM_SETFONT                                     = &H30
%WM_NOTIFY                                      = &H4E
%WM_INITDIALOG                                  = &H110
%WM_COMMAND                                     = &H111
%WM_TIMER                                       = &H113
%WM_CTLCOLORSTATIC                              = &H138
%WM_DROPFILES                                   = &H233
%WS_POPUP                                       = &H80000000
%WS_CHILD                                       = &H40000000
%WS_VISIBLE                                     = &H10000000
%WS_DISABLED                                    = &H08000000
%WS_CAPTION                                     = &H00C00000  ' WS_BORDER OR WS_DLGFRAME
%WS_SYSMENU                                     = &H00080000
%WS_TABSTOP                                     = &H00010000
%WS_MINIMIZEBOX                                 = &H00020000
%WS_EX_TOPMOST                                  = &H00000008
%WS_EX_ACCEPTFILES                              = &H00000010
%WS_EX_WINDOWEDGE                               = &H00000100
%WS_EX_CLIENTEDGE                               = &H00000200
%WS_EX_CONTROLPARENT                            = &H00010000
%SWP_NOSIZE                                     = &H0001
%SWP_NOMOVE                                     = &H0002
%SWP_NOZORDER                                   = &H0004
%HWND_TOPMOST                                   = &HFFFFFFFF???
%COLOR_WINDOW                                   = 5
%COLOR_INFOBK                                   = 24
%IDC_ARROW                                      = 32512&
%IDOK                                           = 1
%IDCANCEL                                       = 2
%BS_AUTOCHECKBOX                                = &H3&
%BN_CLICKED                                     = 0
%BST_CHECKED                                    = &H01
%BM_GETCHECK                                    = &HF0
%BM_SETCHECK                                    = &HF1
%SS_CENTER                                      = &H00000001
%SPI_GETWORKAREA                                = 48
%cmb1                                           = &H470
%HKEY_CURRENT_USER                              = &H80000001???
%HKEY_LOCAL_MACHINE                             = &H80000002???
%VER_PLATFORM_WIN32_NT                          = 2
%CDN_FIRST                                      = 0-601       ' common dialog new
%OFN_HIDEREADONLY                               = &H00000004
%OFN_FILEMUSTEXIST                              = &H00001000
%OFN_EXPLORER                                   = &H00080000 ' new look commdlg
%CDN_INITDONE                                   = %CDN_FIRST - &H0000
%OFN_FILEBUFFERSIZE                             = 8192

$Anti = "\"

TYPE POINTAPI
    x AS LONG
    y AS LONG
END TYPE

TYPE tagMSG
    hwnd AS DWORD
    message AS DWORD
    wParam AS LONG
    lParam AS LONG
    time AS DWORD
    pt AS POINTAPI
END TYPE

TYPE OVERLAPPED
    Internal AS DWORD
    InternalHigh AS DWORD
    offset AS DWORD
    OffsetHigh AS DWORD
    hEvent AS DWORD
END TYPE

TYPE SECURITY_ATTRIBUTES
    nLength AS DWORD
    lpSecurityDescriptor AS LONG
    bInheritHandle AS LONG
END TYPE

TYPE WNDCLASSEX
    cbSize AS DWORD
    STYLE AS DWORD
    lpfnWndProc AS LONG
    cbClsExtra AS LONG
    cbWndExtra AS LONG
    hInstance AS DWORD
    hIcon AS DWORD
    hCursor AS DWORD
    hbrBackground AS DWORD
    lpszMenuName AS ASCIIZ PTR
    lpszClassName AS ASCIIZ PTR
    hIconSm AS DWORD
END TYPE

TYPE RECT
    nLeft AS LONG
    nTop AS LONG
    nRight AS LONG
    nBottom AS LONG
END TYPE

TYPE FILETIME
    dwLowDateTime AS DWORD
    dwHighDateTime AS DWORD
END TYPE

TYPE WIN32_FIND_DATA
    dwFileAttributes AS DWORD
    ftCreationTime AS FILETIME
    ftLastAccessTime AS FILETIME
    ftLastWriteTime AS FILETIME
    nFileSizeHigh AS DWORD
    nFileSizeLow AS DWORD
    dwReserved0 AS DWORD
    dwReserved1 AS DWORD
    cFileName AS ASCIIZ * %MAX_PATH
    cAlternateFileName AS ASCIIZ * 14
END TYPE

TYPE OSVERSIONINFO
    dwOSVersionInfoSize AS DWORD
    dwMajorVersion AS DWORD
    dwMinorVersion AS DWORD
    dwBuildNumber AS DWORD
    dwPlatformId AS DWORD
    szCSDVersion AS ASCIIZ * 128 ' Maintenance string for PSS usage
END TYPE

TYPE NMHDR
    hwndFrom AS DWORD
    idfrom AS DWORD
    code AS LONG ' used for messages, so needs to be LONG, not DWORD...
END TYPE

TYPE OPENFILENAME
    lStructSize       AS DWORD
    hWndOwner         AS LONG
    hInstance         AS LONG
    lpstrFilter       AS ASCIIZ PTR
    lpstrCustomFilter AS ASCIIZ PTR
    nMaxCustFilter    AS DWORD
    nFilterIndex      AS DWORD
    lpstrFile         AS ASCIIZ PTR
    nMaxFile          AS DWORD
    lpstrFileTitle    AS ASCIIZ PTR
    nMaxFileTitle     AS DWORD
    lpstrInitialDir   AS ASCIIZ PTR
    lpstrTitle        AS ASCIIZ PTR
    Flags             AS DWORD
    nFileOffset       AS WORD
    nFileExtension    AS WORD
    lpstrDefExt       AS ASCIIZ PTR
    lCustData         AS LONG
    lpfnHook          AS DWORD
    lpTemplateName    AS ASCIIZ PTR
END TYPE

TYPE OPENFILENAMEEX
    lStructSize       AS DWORD
    hWndOwner         AS DWORD
    hInstance         AS DWORD
    lpstrFilter       AS ASCIIZ PTR
    lpstrCustomFilter AS ASCIIZ PTR
    nMaxCustFilter    AS DWORD
    nFilterIndex      AS DWORD
    lpstrFile         AS ASCIIZ PTR
    nMaxFile          AS DWORD
    lpstrFileTitle    AS ASCIIZ PTR
    nMaxFileTitle     AS DWORD
    lpstrInitialDir   AS ASCIIZ PTR
    lpstrTitle        AS ASCIIZ PTR
    Flags             AS DWORD
    nFileOffset       AS WORD
    nFileExtension    AS WORD
    lpstrDefExt       AS ASCIIZ PTR
    lCustData         AS LONG
    lpfnHook          AS DWORD
    lpTemplateName    AS ASCIIZ PTR
    '--- new Windows 2000 structure members ---
    pvReserved        AS DWORD
    dwReserved        AS DWORD
    FlagsEx           AS DWORD
END TYPE

TYPE TAGOFNOTIFY
    hdr     AS NMHDR
    lpOFN   AS OPENFILENAME
    pszFile AS ASCIIZ PTR
END TYPE

TYPE LIST_ENTRY
    Flink AS LIST_ENTRY PTR
    Blink AS LIST_ENTRY PTR
END TYPE

TYPE RTL_CRITICAL_SECTION_DEBUG
    wType AS WORD
    CreatorBackTraceIndex AS WORD
    CriticalSection AS DWORD  ' actually, CRITICAL_SECTION PTR, but we can't do a circular reference
    ProcessLocksList AS LIST_ENTRY
    EntryCount AS DWORD
    ContentionCount AS DWORD
    Spare(0 TO 1) AS DWORD
END TYPE

TYPE CRITICAL_SECTION
    DebugInfo AS RTL_CRITICAL_SECTION_DEBUG PTR
    ' The following three fields control entering and exiting the critical
    ' section for the resource
    LockCount AS LONG
    RecursionCount AS LONG
    OwningThread AS DWORD    ' from the thread's ClientId->UniqueThread
    LockSemaphore AS DWORD
    SpinCount AS DWORD       ' force size on 64-bit systems when packed
END TYPE

DECLARE FUNCTION zTrace LIB "zTrace.DLL" ALIAS "zTrace" (zMessage AS ASCIIZ) AS LONG

DECLARE FUNCTION AdjustWindowRectEx LIB "USER32.DLL" ALIAS "AdjustWindowRectEx" (lpRect AS RECT, BYVAL dsStyle AS LONG, BYVAL bMenu AS LONG, BYVAL dwEsStyle AS DWORD) AS LONG
DECLARE FUNCTION CreateFile LIB "KERNEL32.DLL" ALIAS "CreateFileA" (lpFileName AS ASCIIZ, BYVAL dwDesiredAccess AS DWORD, BYVAL dwShareMode AS DWORD, lpSecurityAttributes AS SECURITY_ATTRIBUTES, BYVAL dwCreationDisposition AS DWORD, _
                 BYVAL dwFlagsAndAttributes AS DWORD, BYVAL hTemplateFile AS DWORD) AS DWORD
DECLARE FUNCTION CreateWindowEx LIB "USER32.DLL" ALIAS "CreateWindowExA" (BYVAL dwExStyle AS DWORD, lpClassName AS ASCIIZ, lpWindowName AS ASCIIZ, BYVAL dwStyle AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, _
    BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL hWndParent AS DWORD, BYVAL hMenu AS DWORD, BYVAL hInstance AS DWORD, lpParam AS ANY) AS DWORD
DECLARE FUNCTION DefWindowProc LIB "USER32.DLL" ALIAS "DefWindowProcA" (BYVAL hWnd AS DWORD, BYVAL uMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION DispatchMessage LIB "USER32.DLL" ALIAS "DispatchMessageA" (lpMsg AS tagMSG) AS LONG
DECLARE FUNCTION DragQueryFile LIB "SHELL32.DLL" ALIAS "DragQueryFileA" (BYVAL hDrop AS DWORD, BYVAL uiFile AS DWORD, lpStr AS ASCIIZ, BYVAL cch AS DWORD) AS DWORD
DECLARE FUNCTION EnableWindow LIB "USER32.DLL" ALIAS "EnableWindow" (BYVAL hWnd AS DWORD, BYVAL fEnable AS LONG) AS LONG
DECLARE FUNCTION FindClose LIB "KERNEL32.DLL" ALIAS "FindClose" (BYVAL hFindFile AS DWORD) AS LONG
DECLARE FUNCTION FreeLibrary LIB "KERNEL32.DLL" ALIAS "FreeLibrary" (BYVAL hLibModule AS DWORD) AS LONG
DECLARE FUNCTION GetClassInfoEx LIB "USER32.DLL" ALIAS "GetClassInfoExA" (BYVAL hInst AS DWORD, lpszClass AS ASCIIZ, lpWndClass AS WNDCLASSEX) AS LONG
DECLARE FUNCTION GetClientRect LIB "USER32.DLL" ALIAS "GetClientRect" (BYVAL hwnd AS DWORD, lpRect AS RECT) AS LONG
DECLARE FUNCTION GetDlgItem LIB "USER32.DLL" ALIAS "GetDlgItem" (BYVAL hDlg AS DWORD, BYVAL nIDDlgItem AS LONG) AS DWORD
DECLARE FUNCTION GetFileSize LIB "KERNEL32.DLL" ALIAS "GetFileSize" (BYVAL hFile AS DWORD, lpFileSizeHigh AS LONG) AS LONG
DECLARE FUNCTION GetFileType LIB "KERNEL32.DLL" ALIAS "GetFileType" (BYVAL hFile AS DWORD) AS LONG
DECLARE FUNCTION GetLastError LIB "KERNEL32.DLL" ALIAS "GetLastError" () AS LONG
DECLARE FUNCTION GetMessage LIB "USER32.DLL" ALIAS "GetMessageA" (lpMsg AS tagMSG, BYVAL hWnd AS DWORD, BYVAL uMsgFilterMin AS DWORD, BYVAL uMsgFilterMax AS DWORD) AS LONG
DECLARE FUNCTION GetModuleHandle LIB "KERNEL32.DLL" ALIAS "GetModuleHandleA" (lpModuleName AS ASCIIZ) AS DWORD
DECLARE FUNCTION GetOpenFileName LIB "COMDLG32.DLL" ALIAS "GetOpenFileNameA" _
    (lpofn AS OPENFILENAME) AS LONG
DECLARE FUNCTION GetParent LIB "USER32.DLL" ALIAS "GetParent" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION GetPrivateProfileString LIB "KERNEL32.DLL" ALIAS "GetPrivateProfileStringA" (lpApplicationName AS ASCIIZ, lpKeyName AS ASCIIZ, lpDefault AS ASCIIZ, lpReturnedString AS ASCIIZ, BYVAL nSize AS DWORD, lpFileName AS ASCIIZ) AS DWORD
DECLARE FUNCTION GetProcAddress LIB "KERNEL32.DLL" ALIAS "GetProcAddress" (BYVAL hModule AS DWORD, lpProcName AS ASCIIZ) AS LONG
DECLARE FUNCTION GetStockObject LIB "GDI32.DLL" ALIAS "GetStockObject" (BYVAL nIndex AS LONG) AS DWORD
DECLARE FUNCTION GetSysColor LIB "USER32.DLL" ALIAS "GetSysColor" (BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetSysColorBrush LIB "USER32.DLL" ALIAS "GetSysColorBrush" (BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetVersionEx LIB "KERNEL32.DLL" ALIAS "GetVersionExA" (lpVersionInformation AS ANY) AS LONG
DECLARE FUNCTION GetWindowRect LIB "USER32.DLL" ALIAS "GetWindowRect" (BYVAL hWnd AS DWORD, lpRect AS RECT) AS LONG
DECLARE FUNCTION GetWindowText LIB "USER32.DLL" ALIAS "GetWindowTextA" (BYVAL hWnd AS DWORD, lpString AS ASCIIZ, BYVAL cch AS LONG) AS LONG
DECLARE FUNCTION IsCharAlphaNumeric LIB "USER32.DLL" ALIAS "IsCharAlphaNumericA" (BYVAL cChar AS BYTE) AS LONG
DECLARE FUNCTION KillTimer LIB "USER32.DLL" ALIAS "KillTimer" (BYVAL hWnd AS DWORD, BYVAL nIDEvent AS LONG) AS LONG
DECLARE FUNCTION LoadCursor LIB "USER32.DLL" ALIAS "LoadCursorA" (BYVAL hInstance AS DWORD, lpCursorName AS ASCIIZ) AS DWORD
DECLARE FUNCTION LoadIcon LIB "USER32.DLL" ALIAS "LoadIconA" (BYVAL hInstance AS DWORD, lpIconName AS ASCIIZ) AS DWORD
DECLARE FUNCTION LoadLibrary LIB "KERNEL32.DLL" ALIAS "LoadLibraryA" (lpLibFileName AS ASCIIZ) AS LONG
DECLARE FUNCTION MessageBeep LIB "USER32.DLL" ALIAS "MessageBeep" (BYVAL dwType AS DWORD) AS LONG
DECLARE FUNCTION ReadFile LIB "KERNEL32.DLL" ALIAS "ReadFile" (BYVAL hFile AS DWORD, lpBuffer AS ANY, BYVAL nNumberOfBytesToRead AS DWORD, lpNumberOfBytesRead AS DWORD, lpOverlapped AS OVERLAPPED) AS LONG
DECLARE FUNCTION RegCloseKey LIB "ADVAPI32.DLL" ALIAS "RegCloseKey" (BYVAL hKey AS DWORD) AS LONG
DECLARE FUNCTION RegisterClassEx LIB "USER32.DLL" ALIAS "RegisterClassExA" (pcWndClassEx AS WNDCLASSEX) AS WORD
DECLARE FUNCTION RegOpenKeyEx LIB "ADVAPI32.DLL" ALIAS "RegOpenKeyExA" (BYVAL hKey AS DWORD, lpSubKey AS ASCIIZ, BYVAL ulOptions AS DWORD, BYVAL samDesired AS DWORD, phkResult AS DWORD) AS LONG
DECLARE FUNCTION RegQueryValueEx LIB "ADVAPI32.DLL" ALIAS "RegQueryValueExA" (BYVAL hKey AS DWORD, lpValueName AS ASCIIZ, BYVAL lpReserved AS LONG, lpType AS LONG, lpData AS ANY, lpcbData AS LONG) AS LONG
DECLARE FUNCTION SendMessage LIB "USER32.DLL" ALIAS "SendMessageA" (BYVAL hWnd AS DWORD, BYVAL dwMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION SetBkColor LIB "GDI32.DLL" ALIAS "SetBkColor" (BYVAL hdc AS DWORD, BYVAL crColor AS DWORD) AS DWORD
DECLARE FUNCTION SetRect LIB "USER32.DLL" ALIAS "SetRect" (lpRect AS RECT, BYVAL X1 AS LONG, BYVAL Y1 AS LONG, BYVAL X2 AS LONG, BYVAL Y2 AS LONG) AS LONG
DECLARE FUNCTION SetTimer LIB "USER32.DLL" ALIAS "SetTimer" (BYVAL hWnd AS DWORD, BYVAL nIDEvent AS LONG, BYVAL uElapse AS DWORD, BYVAL lpTimerFunc AS LONG) AS LONG
DECLARE FUNCTION SetWindowPos LIB "USER32.DLL" ALIAS "SetWindowPos" (BYVAL hWnd AS DWORD, BYVAL hWndInsertAfter AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL cx AS LONG, BYVAL cy AS LONG, BYVAL wFlags AS DWORD) AS LONG
DECLARE FUNCTION ShellExecute LIB "SHELL32.DLL" ALIAS "ShellExecuteA" (BYVAL hwnd AS DWORD, lpOperation AS ASCIIZ, lpFile AS ASCIIZ, lpParameters AS ASCIIZ, lpDirectory AS ASCIIZ, BYVAL nShowCmd AS LONG) AS DWORD
DECLARE FUNCTION ShowWindow LIB "USER32.DLL" ALIAS "ShowWindow" (BYVAL hWnd AS DWORD, BYVAL nCmdShow AS LONG) AS LONG
DECLARE FUNCTION SystemParametersInfo LIB "USER32.DLL" ALIAS "SystemParametersInfoA" (BYVAL uAction AS DWORD, BYVAL uParam AS DWORD, lpvParam AS ANY, BYVAL fuWinIni AS DWORD) AS LONG
DECLARE FUNCTION TranslateMessage LIB "USER32.DLL" ALIAS "TranslateMessage" (lpMsg AS tagMSG) AS LONG
DECLARE FUNCTION UpdateWindow LIB "USER32.DLL" ALIAS "UpdateWindow" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION WriteFile LIB "KERNEL32.DLL" ALIAS "WriteFile" (BYVAL hFile AS DWORD, lpBuffer AS ANY, BYVAL nNumberOfBytesToWrite AS DWORD, lpNumberOfBytesWritten AS DWORD, lpOverlapped AS OVERLAPPED) AS LONG
DECLARE FUNCTION CloseHandle LIB "KERNEL32.DLL" ALIAS "CloseHandle" (BYVAL hObject AS DWORD) AS LONG
DECLARE FUNCTION SetFileAttributes LIB "KERNEL32.DLL" ALIAS "SetFileAttributesA" (lpFileName AS ASCIIZ, BYVAL dwFileAttributes AS DWORD) AS LONG
DECLARE FUNCTION DeleteFile LIB "KERNEL32.DLL" ALIAS "DeleteFileA" (lpFileName AS ASCIIZ) AS LONG
DECLARE FUNCTION SetFilePointer LIB "KERNEL32.DLL" ALIAS "SetFilePointer" (BYVAL hFile AS DWORD, BYVAL lDistanceToMove AS LONG, lpDistanceToMoveHigh AS LONG, BYVAL dwMoveMethod AS DWORD) AS LONG
DECLARE FUNCTION GetTickCount LIB "KERNEL32.DLL" ALIAS "GetTickCount" () AS DWORD

DECLARE SUB      DragAcceptFiles LIB "SHELL32.DLL" ALIAS "DragAcceptFiles" (BYVAL hwnd AS DWORD, BYVAL fAccept AS LONG)
DECLARE SUB      DragFinish LIB "SHELL32.DLL" ALIAS "DragFinish" (BYVAL hDrop AS DWORD)
DECLARE SUB      PostQuitMessage LIB "USER32.DLL" ALIAS "PostQuitMessage" (BYVAL nExitCode AS LONG)
DECLARE SUB      apiSleep LIB "KERNEL32.DLL" ALIAS "Sleep" (BYVAL dwMilliseconds AS DWORD)

DECLARE SUB DeleteCriticalSection LIB "KERNEL32.DLL" ALIAS "DeleteCriticalSection" (lpCriticalSection AS CRITICAL_SECTION)
DECLARE SUB EnterCriticalSection LIB "KERNEL32.DLL" ALIAS "EnterCriticalSection" (lpCriticalSection AS CRITICAL_SECTION)
DECLARE SUB InitializeCriticalSection LIB "KERNEL32.DLL" ALIAS "InitializeCriticalSection" (lpCriticalSection AS CRITICAL_SECTION)
DECLARE SUB LeaveCriticalSection LIB "KERNEL32.DLL" ALIAS "LeaveCriticalSection" (lpCriticalSection AS CRITICAL_SECTION)

FUNCTION OpenCommDlg_Proc(BYVAL hWnd AS DWORD, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG ) AS LONG
    LOCAL X AS LONG, Y AS LONG, R AS RECT, hftCombo AS DWORD, tNOTIFY AS TAGOFNOTIFY PTR

    IF Msg = %WM_NOTIFY THEN
         tNOTIFY = lParam
         IF @tNOTIFY.hdr.Code = %CDN_INITDONE THEN
            'CENTER DIALOG IN PARENT
            GetWindowRect GetParent(GetParent(hWnd)), R     'get parent's data - dialog is child of child..
            X = R.nLeft + ((R.nRight   - R.nLeft) \ 2)      'calculate parent's width
            Y = R.nTop  + ((R.nBottom  - R.nTop)  \ 2)      'calculate parent's height
            GetWindowRect GetParent(hWnd), R                'get dialog's width and height
            X = X - (( R.nRight   - R.nLeft ) \ 2)
            Y = Y - (( R.nBottom  - R.nTop  ) \ 2)
            SetWindowPos GetParent(hWnd), %NULL, X, Y, 0, 0, %SWP_NOSIZE OR %SWP_NOZORDER 'set centered pos
            'INCREASE HEIGHT OF DROPPED LIST IN FILETYPE COMBO
            hftCombo = GetDlgItem(GetParent(hWnd), %cmb1)   'handle, Filetype combo
            IF hftCombo THEN                                'if we get handle
               CALL GetClientRect(hftCombo, R)              'get combo's width and set new height
               CALL SetWindowPos(hftCombo, %NULL, 0, 0, R.nRight, 200, %SWP_NOMOVE OR %SWP_NOZORDER)
            END IF
            FUNCTION = %TRUE : EXIT FUNCTION
         END IF
    END IF
END FUNCTION

FUNCTION OpenFileDialog (BYVAL hWnd AS DWORD, _           ' parent window
                         BYVAL sCaption AS STRING, _       ' caption
                         sFileSpec AS STRING, _            ' filename
                         BYVAL sInitialDir AS STRING, _    ' start directory
                         BYVAL sFilter AS STRING, _        ' filename filter
                         BYVAL sDefExtension AS STRING, _  ' default extension
                         dFlags AS DWORD) AS LONG          ' flags
    LOCAL ix          AS LONG
    LOCAL Ofn         AS OPENFILENAMEEX
    LOCAL szFileTitle AS ASCIIZ * %MAX_PATH
    REPLACE "|" WITH $NUL IN sFilter
    sFilter = sFilter + $NUL
    IF LEN(sInitialDir) = 0 THEN sInitialDir = CURDIR$
    ix = INSTR(sFileSpec, $NUL)
    IF ix THEN
       sFileSpec = LEFT$(sFileSpec, ix) + SPACE$( MAX&(0, %OFN_FILEBUFFERSIZE - ix) )
    ELSE
       sFileSpec = sFileSpec + $NUL + SPACE$( MAX&(0, %OFN_FILEBUFFERSIZE - (LEN(sFileSpec) + 1)) )
    END IF
    ofn.lStructSize       = LEN(OPENFILENAMEEX) ' if Win2K or later, use full size of new structure
    ofn.hWndOwner         = hWnd
    ofn.lpstrFilter       = STRPTR(sFilter)
    ofn.lpstrFile         = STRPTR(sFileSpec)
    ofn.nMaxFile          = LEN(sFileSpec)
    ofn.lpstrFileTitle    = VARPTR(szFileTitle)
    ofn.nMaxFileTitle     = SIZEOF(szFileTitle)
    ofn.lpstrInitialDir   = STRPTR(sInitialDir)
    IF LEN(sCaption) THEN
        ofn.lpstrTitle    = STRPTR(sCaption)
    END IF
    ofn.Flags             = dFlags
    ofn.lpfnHook          = CODEPTR(OpenCommDlg_Proc)
    IF LEN(sDefExtension) THEN
       ofn.lpstrDefExt  = STRPTR(sDefExtension)
    END IF
    ofn.nFilterIndex = 1  ' nFilterIndex decides File type combo's ListItem
    'Note: following Select Case table must be adjusted to match used Filter string
    '     (also remeber to do the same in OpenDlgHookProc procedure..)
    FUNCTION = GetOpenFilename(BYVAL VARPTR(ofn))
    ix = INSTR(-1, sFileSpec, $NUL)
    IF ix THEN
       sFileSpec = LEFT$(sFileSpec, ix - 1)
    ELSE
       sFileSpec = ""
    END IF
    dFlags = ofn.Flags
END FUNCTION

'// Get control text.
FUNCTION zGetCTLText(BYVAL hWnd AS LONG) AS STRING
    LOCAL szText AS ASCIIZ * 4096, Length AS LONG
    Length = GetWindowText(hWnd, szText, SIZEOF(szText))
    IF Length THEN FUNCTION = LEFT$(szText, Length)
END FUNCTION

'// Changes control text.
SUB zSetCTLText(BYVAL hWnd AS LONG, zText AS ASCIIZ)
    IF hWnd THEN
       IF zText <> zGetCTLText(hWnd) THEN CALL SendMessage(hWnd, %WM_SETTEXT, 0, VARPTR(zText))
    END IF
END SUB

'// Dito LOF
FUNCTION zFLof(BYVAL hFile AS LONG) AS LONG
    LOCAL fSize AS LONG
    IF GetFileType(hFile) = %FILE_TYPE_DISK THEN
       fSize = GetFileSize(hFile, BYVAL %NULL)
       IF fSize > -1& THEN FUNCTION = fSize
    END IF
END FUNCTION

'// Dito Put
FUNCTION zFPut (BYVAL hFile AS LONG, BYVAL sBuffer AS STRING) AS LONG
    LOCAL LenBuf, ByttesWritten AS LONG
    IF hFile THEN
       LenBuf = LEN(sBuffer)
       IF LenBuf THEN
          IF WriteFile(hFile, BYVAL STRPTR(sBuffer), LenBuf, ByttesWritten, BYVAL %NULL) = 0 THEN
             FUNCTION = GetLastError()
          END IF
       END IF
    END IF
END FUNCTION

'// Dito Get
FUNCTION zFGet (BYVAL hFile AS LONG, BYREF sBuffer AS STRING) AS LONG
    LOCAL LenBuf, ByttesReaded AS LONG
    IF hFile THEN
       LenBuf = LEN(sBuffer)
       IF LenBuf THEN
          IF ReadFile(hFile, BYVAL STRPTR(sBuffer), LenBuf, ByttesReaded, BYVAL %NULL) = 0 THEN
             FUNCTION = GetLastError
          END IF
       END IF
    END IF
END FUNCTION

'// Dito SEEK
FUNCTION zFSeek (BYVAL hFile AS LONG, BYVAL PosByte AS LONG) AS LONG
    IF SetFilePointer(hFile, PosByte, BYVAL %NULL, 0) < 0 THEN
       FUNCTION = GetLastError
    END IF
END FUNCTION

'// GET at a specific offset
FUNCTION zFGetAt (BYVAL hFile AS LONG, BYVAL nPosByte AS LONG, sBuf AS STRING) AS LONG
    LOCAL nErrCode AS LONG
    nErrCode = zFSeek(hFile, nPosByte)
    IF nErrCode = 0 THEN nErrCode = zFGet(hFile, sBuf)
    FUNCTION = nErrCode
END FUNCTION

'// Generic open file function
FUNCTION zFOpen (zFilName AS ASCIIZ, BYVAL AccessMode AS LONG, BYVAL ShareMode AS LONG, hFile AS LONG) AS LONG

    LOCAl AccessIs, ShareIs, FlagAndAttribute AS LONG

    AccessMode = MIN(MAX(AccessMode, 0), 2)  ' Coherce between 0-2
    IF AccessMode = 0 THEN                   ' 0 Open for read only.
       AccessIs = %GENERIC_READ
    ELSEIF AccessMode = 1 THEN               ' 1 Open for write only.
       AccessIs = %GENERIC_WRITE
    ELSE                                     ' 2 Open for read and write.
       AccessIs = %GENERIC_READ OR %GENERIC_WRITE
    END IF

    ShareMode = MIN(MAX(ShareMode, 1), 4)    ' Coherce between 1-4
    IF ShareMode = 1 THEN                    ' 1 Deny read/write access.
       ShareIs = 0
    ELSEIF ShareMode = 2 THEN                ' 2 Deny write access.
       ShareIs =  %FILE_SHARE_READ
    ELSEIF ShareMode = 3 THEN                ' 3 Deny read access.
       ShareIs =  %FILE_SHARE_WRITE
    ELSE                                     ' 4 Deny none (full share mode).
       ShareIs =  %FILE_SHARE_READ OR %FILE_SHARE_WRITE
    END IF

    IF hFile = -1 THEN
       FlagAndAttribute = %FILE_ATTRIBUTE_NORMAL OR %FILE_FLAG_WRITE_THROUGH
    ELSE
       FlagAndAttribute = %FILE_ATTRIBUTE_NORMAL
    END IF

    hFile = CreateFile(zFilName, AccessIs, ShareIs, BYVAL %NULL, %OPEN_ALWAYS, FlagAndAttribute, BYVAL %NULL)

    IF hFile = CLNG(%INVALID_HANDLE_VALUE) THEN    ' -1 Fail to create the file
       FUNCTION = GetLastError               ' Set the error code
       hFile = 0                             ' Reset handle number
    END IF

END FUNCTION

'// Dito CLOSE
SUB zFClose (hFile AS LONG)
    IF hFile THEN CALL CloseHandle(hFile)
    hFile = 0
END SUB

'// Delete a file or group of files.
FUNCTION zKillFile(BYVAL sFullName AS STRING) AS LONG
    LOCAL szName AS ASCIIZ * %MAX_PATH, sPath AS STRING
    IF LEN(sFullName) THEN
       sPath = PATHNAME$(PATH, sFullName)
       ToKill$ = DIR$(sFullName, 39) ' %NORMAL + %READONLY + %HIDDEN + %SYSTEM + %ARCHIVE
       DO WHILE LEN(ToKill$)
          szName = sPath + ToKill$
          CALL SetFileAttributes(szName, %FILE_ATTRIBUTE_NORMAL)
          IF DeleteFile(szName) = 0 THEN FUNCTION = GetLastError: EXIT DO
          ToKill$ = DIR$
       LOOP
    END IF
END FUNCTION

FUNCTION zUseWriteName(BYVAL sName AS STRING, BYVAL RW AS LONG) AS STRING
    STATIC sWasName AS STRING
    IF RW THEN sWasName = sName
    FUNCTION = sWasName
END FUNCTION

SUB zWrite(BYVAL sMsg AS STRING) STATIC
    DIM szFileName AS ASCIIZ * %MAX_PATH
    DIM hFile AS LONG
    DIM NeverBeenThere AS LONG
    IF hFile AND LEN(sMsg$) = 0 THEN
       CALL zFClose(hFile)
       NeverBeenThere = 0
       EXIT SUB
    END IF
    IF NeverBeenThere = 0 THEN
       NeverBeenThere = -1
       szFileName = zUseWriteName("", 0)
       CALL zKillFile(szFileName)
       CALL zFOpen(szFileName, 2, 4, hFile)
    END IF
    CALL zFPut(hFile, RTRIM$(sMsg) + $CRLF)
END SUB

FUNCTION zUseBuildName(BYVAL sName AS STRING, BYVAL RW AS LONG) AS STRING
    STATIC sWasName AS STRING
    IF RW THEN sWasName = sName
    FUNCTION = sWasName
END FUNCTION

SUB zBuild(BYVAL sBuf AS STRING, BYVAL RW AS LONG) STATIC
    DIM szFileName AS ASCIIZ * %MAX_PATH
    DIM hFile AS LONG
    DIM NeverBeenThere AS LONG
    IF hFile AND RW = 0 THEN
       CALL zFClose(hFile)
       NeverBeenThere = 0
       EXIT SUB
    END IF
    IF NeverBeenThere = 0 THEN
       NeverBeenThere = -1
       szFileName = zUseBuildName("", 0)
       CALL zKillFile(szFileName)
       CALL zFOpen(szFileName, 2, 4, hFile)
    END IF
    CALL zFPut(hFile, sBuf)
END SUB

'// Changes the character being used as delimiter to read in a sequential text file.
FUNCTION zSetBufinChar (BYVAL Char$) STATIC AS STRING
    IF LEN(Char$) THEN UserChar$ = Char$
    IF LEN(UserChar$) THEN
       FUNCTION = UserChar$
    ELSE
       FUNCTION = CHR$(13)
    END IF
END FUNCTION

DECLARE FUNCTION FindFile LIB "KERNEL32.DLL" ALIAS "FindFirstFileA" (lpFileName AS ASCIIZ, lpFindFileData AS WIN32_FIND_DATA) AS LONG
FUNCTION zExist ALIAS "zExist" (BYVAL sFileSpec AS STRING) EXPORT AS LONG
    LOCAL fd AS WIN32_FIND_DATA, hFind AS LONG
    IF LEN(sFileSpec) THEN
       hFind = FindFile(BYVAL STRPTR(sFileSpec), fd)
       IF hFind <> -1 THEN
          CALL FindClose(hFind)
          FUNCTION = -1
       END IF
    END IF
END FUNCTION

'// Fast sequential line input replacement.
FUNCTION zBufin (zFileName AS ASCIIZ, nDone AS LONG) STATIC AS STRING
    DIM sCr AS STRING, sBuffer AS STRING
    DIM hFile AS LONG, nLocation AS LONG, nBufSize AS LONG, nBufPos AS LONG, nErrCode AS LONG, nRemaining AS LONG
    DIM nCr AS LONG, nSlop AS LONG, nReading AS LONG, nLenCr AS LONG, nSizeFile AS LONG, nSaveCr AS LONG

    IF LEN(zFileName) THEN
       IF NOT nReading THEN
          sCr = zSetBufinChar("")           ' added for spec char
          nReading = -1: nDone = 0
          IF ASC(sCr) = 13 THEN             ' added for spec char
             nLenCr = 0: sCr = CHR$(13)
          ELSE                              ' added for spec char
             nLenCr = LEN(sCr)              ' added for spec char
          END IF                            ' added for spec char
          nCr = 0: nLocation = 0
          IF NOT zExist(zFileName) THEN GOTO BufEnd  ' Nothing to do
          nErrCode = zFOpen(zFileName, 0, 2, hFile)
          IF nErrCode THEN
             nDone = nErrCode: nReading = 0
             EXIT FUNCTION
          END IF
          nRemaining = zFLof(hFile)                  ' Bytes count to be read
          nSizeFile = nRemaining                     ' Remember this
          IF nRemaining = 0 GOTO BufEnd              ' Nothing to read
          nBufSize = 16384
          sBuffer = SPACE$(nBufSize)
       END IF
       DO WHILE nRemaining                           ' While more in the file
          IF nCr = 0 THEN                            ' If no return was found
             IF nRemaining < nBufSize THEN           ' read only what remains.
                nBufSize = nRemaining                ' Resize the buffer.
                IF nBufSize < 1 THEN EXIT DO         ' Possible only if EOF 26.
                sBuffer = SPACE$(nBufSize)
             END IF
             nErrCode = zFGetAt(hFile, nLocation, sBuffer) ' Read a bloc.
             nLocation = nLocation + nBufSize        ' Here we are.
             nBufPos = 1                             ' Start at the beginning
          END IF                                     ' of that bloc.
          DO                                         ' Walk through buffer.
             nCr = INSTR(nBufPos, sBuffer, sCr)      ' Look for a Return.
             IF nLenCr = 0 THEN                      ' Do this to read files with
                nLenCr = 1                           ' or without LF after CR.
                IF ASC(sBuffer, nCr + 1) = 10 THEN nLenCr = 2
             END IF
             IF nCr THEN                             ' We found one.
                nSaveCr = nCr                        ' Save where
                FUNCTION = MID$(sBuffer, nBufPos, nCr - nBufPos)
                nBufPos = nCr + nLenCr               ' In case of LF skip it
                EXIT FUNCTION                        ' all done for now.
             ELSE                                    ' Back up in the file.
              ' If we reached the end of file and no nCr
              ' was found, return what remains in the string.
                IF nLocation >= nSizeFile THEN
                 ' Assign function and trap ^Z
                   FUNCTION = RTRIM$(MID$(sBuffer, nSaveCr + nLenCr), CHR$(26))
                   nRemaining = nBufSize
                   EXIT DO
                END IF
              ' 05-06-1998 () were missing on each side of (nLenCr - 1)
                nSlop = nBufSize - nSaveCr - (nLenCr - 1) ' Calc buffer excess.
                nRemaining = nRemaining + nSlop           ' Calc file excess.
                nLocation = nLocation - nSlop
             END IF
          LOOP WHILE nCr                                  ' While more in buffer.
          nRemaining = nRemaining - nBufSize
          nSaveCr = 0
       LOOP
    END IF

BufEnd:
    nReading = 0: nDone = -1: CALL zFClose(hFile)
END FUNCTION

FUNCTION CheckInclude(BYVAL sFileName AS STRING) AS LONG
    LOCAL sS AS STRING
    sS = ",": sFileName = sS + UCASE$(sFileName) + sS
    FUNCTION = INSTR(ZX_EXCLUDE(), sFileName)
END FUNCTION

FUNCTION CheckMain(BYVAL sFileName AS STRING) AS LONG
    sFileName = UCASE$(sFileName) + ","
    FUNCTION = INSTR("PBMAIN,WINMAIN,LIBMAIN,PBLIBMAIN,DLLMAIN,", sFileName)
END FUNCTION

FUNCTION SplitPath(BYVAL sPathName AS STRING) AS STRING
    FUNCTION = LEFT$(sPathName, INSTR(-2, sPathName, $Anti))
END FUNCTION

'// Decode the config file.
SUB ReadConfig()
    LOCAL S1, S2, S3, nItem, nDone, nMic AS LONG, sCfg, sBF AS STRING
    LOCAL zConfigFile AS ASCIIZ * %MAX_PATH
    zConfigFile = EXE.Path$ + EXE.Name$ + ".cfg"
    IF zExist(zConfigFile) THEN
       nItem = 0
       DO WHILE nDone = 0
          sCfg = LTRIM$(zBufin(zConfigFile, nDone))
          IF LEN(sCfg) THEN
             IF LEFT$(sCfg, 2) = "//" OR ASC(sCfg) = 39 THEN sCfg = ""
             IF LEN(sCfg) THEN
                S1 = INSTR(sCfg, CHR$(96)) ' "`"
                S2 = INSTR(-1, sCfg, CHR$(34))
                IF S1 = 0 THEN
                   S3 = INSTR(-1, sCfg, "'"): IF S3 > S2 THEN S1 = S3
                END IF
                IF S1 THEN sCfg = RTRIM$(LEFT$(sCfg, S1 - 1))
                S1 = INSTR(sCfg, CHR$(34))
                IF S1 AND S1 < S2 THEN
                   nMiC = ASC(sCfg, LEN(sCfg))
                   sCfg = MID$(sCfg, S1 + 1, S2 - S1 - 1)
      
                   sBF = sBF + sCfg
                   IF nMiC <> 95 THEN ' "_" continuation character 
                      INCR nItem
                      ON nItem GOSUB SCANPATH,EXCLUDE,CONSTANT
                      sBF = ""
                   END IF
                END IF
             END IF
          END IF
       LOOP
    END IF
    EXIT SUB

SCANPATH:
    CALL zSCANPATH(TRIM$(REMAIN$(sBF, ":"), ANY CHR$(32,34)), 1)
    RETURN

EXCLUDE:
    CALL zEXCLUDE(TRIM$(REMAIN$(sBF, ":"), ANY CHR$(32,34)), 1)
    RETURN

CONSTANT:
    CALL zCONSTANT(TRIM$(REMAIN$(sBF, ":"), ANY CHR$(32,34)), 1)
    RETURN
END SUB

FUNCTION zSCANPATH(BYVAL sText AS STRING, BYVAL RW AS LONG) AS STRING
    STATIC sWasText AS STRING
    LOCAL sS AS STRING
    sS = ";"
    IF RW THEN sWasText = sText
    FUNCTION = LTRIM$(RTRIM$(sWasText, sS) + sS + ENVIRON$("PATH"), sS)
END FUNCTION
FUNCTION ZX_SCANPATH() AS STRING
    FUNCTION = zSCANPATH("", 0)
END FUNCTION

FUNCTION zEXCLUDE(BYVAL sText AS STRING, BYVAL RW AS LONG) AS STRING
    STATIC sWasText AS STRING
    LOCAL sS AS STRING
    sS = ","
    IF RW THEN sWasText = sText
    FUNCTION = sS + LTRIM$(sWasText, sS)
END FUNCTION
FUNCTION ZX_EXCLUDE() AS STRING
    FUNCTION = zEXCLUDE("", 0)
END FUNCTION

FUNCTION zCONSTANT(BYVAL sText AS STRING, BYVAL RW AS LONG) AS STRING
    STATIC sWasText AS STRING
    LOCAL sS AS STRING
    sS = ","
    IF RW THEN sWasText = sText
    FUNCTION = sS + LTRIM$(sWasText, sS)
END FUNCTION
FUNCTION ZX_CONSTANT() AS STRING
    FUNCTION = zCONSTANT("", 0)
END FUNCTION

FUNCTION zMainWindow(BYVAL hMain AS LONG) AS LONG
    STATIC WasMain AS LONG
    IF hMain THEN
       WasMain = hMain
    END IF
    FUNCTION = WasMain
END FUNCTION

FUNCTION zFindFile(BYVAL sFileName AS STRING) AS STRING
    LOCAL sPath, sDir, sFullName AS STRING, K, nCount AS LONG
    IF LEN(sFileName) THEN
       sFileName = PATHNAME$(NAMEX, sFileName)
       sPath = ZX_SCANPATH()
       nCount = PARSECOUNT(sPath, ";")
       FOR K = 1 TO nCount
           sDir = RTRIM$(PARSE$(sPath, ";", K), $Anti) + $Anti
           sFullName = sDir + sFileName
           IF zExist(sFullName) THEN EXIT FOR
           sFullName = ""
       NEXT
       FUNCTION = sFullName
    END IF
END FUNCTION

FUNCTION UcaseCrunchSpace(BYVAL sExpr AS STRING) AS STRING
    LOCAL n AS LONG
    sExpr = TRIM$(EXTRACT$(sExpr, "'"))
    IF LEN(sExpr) THEN
       sExpr = UCASE$(sExpr)
       n = 1
       DO
          n = INSTR(n, sExpr, " "): IF n THEN sExpr = LEFT$(sExpr, n) + LTRIM$(MID$(sExpr, n + 1)): n += 1
       LOOP UNTIL n = 0
    END IF
    FUNCTION = sExpr
END FUNCTION

'///////////////////////
%ID_STATIC             = -12
%ID_CONSTANT           = -13
%ID_TYPE               = -14
%ID_UNRESOLVED         = -15

%LB_ADDSTRING          = &H180
%LB_INSERTSTRING       = &H181
%LB_FINDSTRING         = &H18F
%LB_GETTEXT            = &H189
%LB_GETTEXTLEN         = &H18A
%LB_DELETESTRING       = &H182
%LB_RESETCONTENT       = &H184
%LB_SETCURSEL          = &H186
%LB_GETCURSEL          = &H188
%LB_GETCOUNT           = &H18B
%LBS_HASSTRINGS        = &H40&
%LBS_SORT              = &H2&

FUNCTION zInstance () AS LONG
    FUNCTION = GetModuleHandle("")
END FUNCTION

FUNCTION zGetMainItem(BYVAL UseID AS LONG) AS LONG
    FUNCTION = GetDlgItem(zMainWindow(0), UseID)
END FUNCTION

'FUNCTION GetStaticValue(BYVAL sUseString AS STRING) AS LONG
'    LOCAL nValue, nStaticHandle, nIndex AS LONG
'    sUseString += "|"
'    nStaticHandle = zGetMainItem(%ID_STATIC)
'    IF nStaticHandle THEN
'       nIndex = SendMessage(nStaticHandle, 399, -1, STRPTR(sUseString))
'       IF nIndex > -1 THEN '// We found it
'          nValue = SendMessage(nStaticHandle, 409, nIndex, 0)
'       END IF
'    END IF
'    FUNCTION = nValue
'END FUNCTION

SUB SetStaticValue(BYVAL nUseID AS LONG, BYVAL sUseString AS STRING, BYVAL nValue AS LONG)
    LOCAL nStaticHandle, nIndex AS LONG, sS AS STRING
    sS = "|": IF INSTR(sUseString, sS) = 0 THEN sUseString += "|"
    nStaticHandle = zGetMainItem(nUseID)
    IF nStaticHandle = 0 THEN
       nStaticHandle = CreateWindowEx(0, "LISTBOX", "", %WS_CHILD OR %LBS_HASSTRINGS, _
                                      0, 0, 0, 0, zMainWindow(0), _
                                      nUseID, zInstance(), BYVAL %NULL)
    END IF
    IF nStaticHandle THEN
       sS = EXTRACT$(sUseString, sS) + sS
       nIndex = SendMessage(nStaticHandle, 399, -1, STRPTR(sS))
       IF nIndex > -1 THEN '// We found same static
          CALL SendMessage(nStaticHandle, 410, nIndex, nValue)
       ELSE '// Add it to our static list
          CALL SendMessage(nStaticHandle, 410, SendMessage(nStaticHandle, 384, 0, STRPTR(sUseString)), nValue)
       END IF
    END IF
END SUB

SUB ListDeleteAll(BYVAL hList AS LONG)
    IF hList THEN CALL SendMessage(hList, %LB_RESETCONTENT, 0, 0)
END SUB

SUB ListResetAll()
    LOCAL hList AS LONG
    ListDeleteAll(zGetMainItem(%ID_STATIC))
    ListDeleteAll(zGetMainItem(%ID_CONSTANT)) 
    ListDeleteAll(zGetMainItem(%ID_TYPE))
    ListDeleteAll(zGetMainItem(%ID_UNRESOLVED))
END SUB

'SUB ListDelete(BYVAL hList AS LONG, BYVAL nIndex AS LONG)
'    IF nIndex > 0 THEN DECR nIndex '// Because ListBox is zero based
'    IF hList THEN CALL SendMessage(hList, %LB_DELETESTRING, nIndex, 0)
'END SUB

'SUB ListSelectPlus(BYVAL hList AS LONG, BYVAL nSelected AS LONG)
'    IF nSelected > 0 THEN DECR nSelected '// Because ListBox is zero based
'    IF hList THEN CALL SendMessage(hList, %LB_SETCURSEL, nSelected, 0)
'END SUB

FUNCTION ListExist(BYVAL nUseID AS LONG, BYVAL sUseString AS STRING) AS LONG
    LOCAL nListHandle, nIndex AS LONG, sS AS STRING
    nListHandle = zGetMainItem(nUseID)
    IF nListHandle THEN
       sS = "|": sUseString = EXTRACT$(sUseString, sS) + sS
       nIndex = SendMessage(nListHandle, 399, -1, STRPTR(sUseString))
'       IF nIndex > -1 THEN INCR nIndex: FUNCTION = nIndex
       IF nIndex > -1 THEN FUNCTION = -1
    END IF
END FUNCTION

'FUNCTION ListFindString(BYVAL hList AS LONG, zTmp AS ASCIIZ) AS LONG
'    LOCAL nIndex AS LONG
'    nIndex = SendMessage(hList, %LB_FINDSTRING, -1, VARPTR(zTmp))
'    IF nIndex > -1 THEN INCR nIndex: FUNCTION = nIndex
'END FUNCTION

FUNCTION ListCount(BYVAL hList AS LONG) AS LONG
    IF hList THEN FUNCTION = SendMessage(hList, %LB_GETCOUNT, 0, 0)
END FUNCTION

'FUNCTION ListGetCursel(BYVAL hList AS LONG) AS LONG
'    LOCAL nSelected AS LONG
'    IF hList THEN
'       nSelected = SendMessage(hList, %LB_GETCURSEL, 0, 0)
'       IF nSelected > -1 THEN INCR nSelected '// Because ListBox is zero based
'    END IF
'    FUNCTION = nSelected
'END FUNCTION

'FUNCTION ListAdd(BYVAL hList AS LONG, zTmp AS ASCIIZ) AS LONG
'    IF hList THEN
'       IF LEN(zTmp) THEN FUNCTION = SendMessage(hList, %LB_ADDSTRING, 0, VARPTR(zTmp))
'    END IF
'END FUNCTION

'FUNCTION ListGetText(BYVAL hList AS LONG, BYVAL Item AS LONG) AS STRING
'    LOCAL sItem AS STRING, nLEN AS LONG
'    IF Item > 0 THEN
'       DECR Item
'       nLEN = SendMessage(hList, %LB_GETTEXTLEN, Item, 0)
'       sItem = SPACE$(nLEN)
'       CALL SendMessage(hList, %LB_GETTEXT, Item, BYVAL STRPTR(sItem))
'       FUNCTION = sItem
'    END IF
'END FUNCTION

DECLARE FUNCTION PeekMessage LIB "USER32.DLL" ALIAS "PeekMessageA" (lpMsg AS tagMSG, BYVAL hWnd AS DWORD, BYVAL dwMsgFilterMin AS DWORD, BYVAL dwMsgFilterMax AS DWORD, BYVAL dwRemoveMsg AS DWORD) AS LONG

FUNCTION zDoEvents () AS LONG
    STATIC Msg AS TagMsg
    IF PeekMessage(Msg, %NULL, 0, 0, &H0001) THEN ' %PM_REMOVE) THEN
       IF Msg.message = &H12 THEN ' %WM_QUIT THEN
          CALL PostQuitMessage(Msg.wParam)
          FUNCTION = Msg.message: EXIT FUNCTION
       END IF
       CALL TranslateMessage(Msg)
       CALL DispatchMessage(Msg)
    END IF
'    CALL apiSLEEP(0)
END FUNCTION
